import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class ActorBase extends Actor
{
    public boolean shouldScroll;
    public int playerX;
    
    public void act() 
    {
        updateShouldScroll(200, 400); //This should be in the act method so that the shouldScroll boolean is constantly updated.
    }
    
    /**
     * This method checks the players x position and sets the shouldScroll boolean accordingly.
     * @param The x value limits within which scrolling is not required for left/right movement.
     */
public void updateShouldScroll(int minX, int maxX)
    {
        MyWorld theWorld = (MyWorld) getWorld();
        Player player = (Player) theWorld.getPlayer();
        if(player == null || player.getWorld() == null)
            return;
        playerX = player.getX();
        if(playerX <= minX || playerX >= maxX)
        {
            shouldScroll = true;
        }
        else
        {
            shouldScroll = false;
        }
        if(shouldScroll == true && (playerX >= 600 && Greenfoot.isKeyDown("left")) || (playerX <= 300 && Greenfoot.isKeyDown("right")))
        {
            shouldScroll = false;
        }
    }   
}
